# I will try and make this quality checks file as standard as possible
# so that it can be used in a lot of different scenarios
# It will take in the directory it needs to check and then perform multiple different 
# checks on the data.

import sys
import os
import argparse
import pandas as pd
import xarray as xr
import numpy as np
import netCDF4 as nc4
from netCDF4 import Dataset as nc
from io import StringIO
import paramiko 


class Checks:
    """
    Base class for possible checks of any dataset
    """

    def __init__(self, indir, file):
        self.indir = indir
        self.file = file
        self.filepath = os.path.join(self.indir, self.file)

    def check_that_file_exists(self):
        """
        Checking that the file exists in a certain directory
        """
        print("Checking if file exists")
        if not os.path.exists(self.filepath):
            return "File does not exist in the destination {}".format(self.filepath)

    def check_corrupted_netcdf(self):
        """
        Checking for a corrupted file by attepting to open the file with xarray
        """
        try:
            xr.open_dataset(self.filepath)
        except OSError:
            print("File corrupted")
            return "File {} is corrupted and needs redownloading again".format(self.filepath)

    def check_file_size(self, size_in_bytes=0):
        """
        Checking file size is less than a certain value that indicates that it has been downloaded incorrectly
        """
        print("Checking size of file")
        if os.path.getsize(self.filepath) <= size_in_bytes:
            return "File size is less than {} bytes - please check that it is not corrupted".format(size_in_bytes)


    def send_email_over_ssh(self, error_list):
        """
        Send the emails of the errors
        """
        client = paramiko.SSHClient()
        client.set_missing_host_key_policy(paramiko.AutoAddPolicy())
        client.connect('bscesoper.bsc.es', username='cmeikle', password='Trek3.1')
        print("sending error")
        print(error_list)
        for error in error_list:
            command = "/home/Earth/pbretonn/./sendemail.sh Calum test {} - {}".format(self.dataset, error)
            print(command)
            stdin, stdout, stderr = client.exec_command(command)
            error = stderr.read().decode().strip()
            if error:
                raise Exception('There was an error pulling the runtime: {}'.format(error))
        client.close()
        print("finish sending error")

        